import bpy

####### Object Baking Panel

class BLENRIG_PT_BlenRig_5_mesh_panel(bpy.types.Panel):
    bl_region_type = 'WINDOW'
    bl_space_type = 'VIEW_3D'
    bl_idname = "BLENRIG_PT_BlenRig_5_mesh_panel"
    bl_parent_id = "BLENRIG_PT_BlenRig_5_general"
    bl_region_type = 'UI'
    bl_label = 'BlenRig 5 Mesh Baking Panel'
    bl_category = "BlenRig 5"

    @classmethod
    def poll(cls, context):
        BlenRigPanelOptions = context.window_manager.BlenRigPanelSettings
        if not BlenRigPanelOptions.displayContext == 'RIGTOOLS':
            return False
        
        if context.mode in ["EDIT_MESH"]:
            return False

        if not bpy.context.active_object:
            return False
        if (bpy.context.active_object.type in ["MESH"]):
            for mod in bpy.context.active_object.modifiers:
                if (mod.type in ["ARMATURE", "MESH_DEFORM"]):
                    return True

    def draw(self, context):
        props = context.window_manager.blenrig_5_props
        layout = self.layout
        
        box = layout.column()
        col = box.column()
        row = col.row()
    # expanded box
        col.separator
        row = col.row()
        row.operator("blenrig5.mesh_pose_baker", text="Bake Mesh")
        row.prop(props, "bake_to_shape")

####### Lattice & Curves Panel

class BLENRIG_PT_BlenRig_5_lattice_panel(bpy.types.Panel):
    bl_label = "BlenRig 5 Lattice & Curves Panel"
    bl_idname = "BLENRIG_PT_BlenRig_5_lattice_panel"
    bl_parent_id = "BLENRIG_PT_BlenRig_5_general"
    bl_region_type = 'WINDOW'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_category = "BlenRig 5"

    @classmethod
    def poll(cls, context):
        BlenRigPanelOptions = context.window_manager.BlenRigPanelSettings
        if not BlenRigPanelOptions.displayContext == 'RIGTOOLS':
            return False

        if not context.active_object:
            return False
        if (context.active_object.type in ["LATTICE", "CURVE"]):
            for mod in context.active_object.modifiers:
                if (mod.type in ["HOOK"]):
                    return True

    def draw(self, context):
        props = context.window_manager.blenrig_5_props
        layout = self.layout

        row = layout.row(align=False)
        row.operator("blenrig5.disable_hooks_modif", text="Modify Lattice Position")

        sub = layout.row(align=False)
        sub = row.row()
        sub.scale_x = 0.6
        sub.operator("blenrig5.reset_hooks", text="Apply Lattice Position")